class Is {
    static callToString(arg) {
        return Object.prototype.toString.call(arg)
    };

    static $string(arg) {
        return Is.callToString(arg) === '[object String]';
    };

    static is(arg, type){
        let response = false;
        if (Is.$string(type))
            response = Is.callToString(arg) === `[object ${type}]`;
        else if(Is.$function(type))
            response = arg instanceof type;
        return response;
    };

    static $array(arg){
        return Is.is(arg, 'Array');
    };

    static $null(arg){
        return Is.is(arg, 'Null');
    };

    static $number(arg){
        return Is.is(arg, 'Number');
    };

    static $object(arg){
        return Is.is(arg, 'Object');
    };

    static $undefined(arg){
        return Is.is(arg, 'Undefined');
    };

    static $boolean(arg){
        return Is.is(arg, 'Boolean');
    };

    static $function(arg){
        return Is.callToString(arg) === '[object Function]';
    };
}

module.exports = Is;